# 

# Contributors to DDI-CDI Development

**Members of the Cross Domain Integration (CDI) Working Group**
shepherded the standard into its final form and produced the final
documentation. Listed in alphabetical order they are:

-   Arofan Gregory (chair)
-   Dan Gillman
-   Flavio Rizzolo
-   Hilde Orten
-   Jay Greenfield
-   Joachim Wackerow
-   Larry Hoyle
-   Oliver Hopt
-   Wendy Lee Thomas (Technical Committee contact)

DDI-CDI evolved from the earlier DDI Moving Forward (DDI 4) effort. That
effort involved multiple teams and in-person meetings (Sprints), both in
Europe and North America. The first Moving Forward sprint took place at
Schloss Dagstuhl, the Leibniz Center for Informatics, in October 2012.
Five goals were listed: Improve DDI usability, Expand DDI coverage,
Express the model in different technical format, Repackage the
specification, and Enhance the documentation.

In time, the effort became extremely broad. The development of DDI
Moving Forward (DDI 4) involved 23 multi-day working events since 2012
(total of 109 days), 14 working groups, 115 participants coming from 65
organizations. The result of this work was a distilled mass of knowledge
coming from the community which serves not only as the foundation of
DDI-CDI but will also be the basis of future work.

An early decision was to use a subset of UML to represent the model.
That has carried over to DDI-CDI, with a UML model expressed in
canonical XMI as the official representation of the model and with other
syntax representations (XML, RDF) generated from the XMI. This has
resulted in the development of UML Class Model Interoperable Subset
(UCMIS) as a supporting tool for data modelling, both for DDI-CDI and
potentially other specifications.

As the project proceeded, the goals evolved. What had always been
focused on the social science domain become something broader. Even
within the social sciences the requirement for describing a broader
range of data had emerged. The CDI Working Group decided to produce a
specification which could be applied not only to social science data,
but to data coming from any domain. An effort was made to expand beyond
the social science perspective and describe data in a fashion applicable
across different domains.

In parallel with the evolution of the Moving Forward model, a
collaboration between DDI and CODATA clarified the need for a standard
supporting interoperability of metadata standards in cross-domain
research. The Moving Forward effort evolved into DDI-Cross Domain
Integration to meet this need.

DDI-CDI attempts to describe data in a generic way, with a powerful and
flexible referencing mechanism to link to metadata in more domain
specific metadata standards, including DDI Codebook and Lifecycle. It
allows for describing data at the Datum level, and along with that,
allows for tracking individual data observations across multiple
representations in varying structures.

## Members of the Cross Domain Integration (CDI) Working Group since 2023

-   Benjamin Beuster
-   Darren Bell
-   Deirdre Lungley
-   John Kunze

---

A spreadsheet containing a listing of all participants by event can be
found at
https://github.com/ddi-cdi/ddi-cdi/blob/main/DDI-MovingForward_DDI-CDI_Contributors.xlsx.

The people listed below have contributed to either the DDI Moving
Forward project or to the development of DDI-CDI.

People are listed as members of teams, or as having attended an
in-person development event (sprint).

## Several people contributed to 11 or more teams and sprints:

-   Arofan Gregory
-   Barry Radler
-   Dan Gillman
-   Flavio Rizzolo
-   Jay Greenfield
-   Joachim Wackerow
-   Jon Johnson
-   Larry Hoyle
-   Oliver Hopt
-   Olof Olsson
-   Steve McEachern
-   Wendy Thomas

## A substantial group of people contributed to between 4 and 10 teams and sprints. They are:

-   Brigitte Mathiak
-   Dan Smith
-   Darren Bell
-   Eric Prud'hommeaux
-   Guillaume Duffes
-   Hilde Orten
-   Jannik Jensen
-   Jared Lyle
-   Jenny Linnerud
-   Jeremy Iverson
-   Johan Fihn Marberg
-   Kelly Chatain
-   Knut Wenzig
-   Marcel Hebing
-   Mary Vardigan
-   Michelle Edwards
-   Ørnulf Risnes
-   Ron Nakao
-   Sanda Ionescu
-   Thérèse Lalor
-   Wolfgang Zenk-Möltgen

## Many other people contributed to between one and three teams and sprints. They are:

-   Adam Brown
-   Alan Li
-   Alberto Abella
-   Alejandra Gonzalez-Beltran
-   Amber Leahey
-   Anders Swendsrud
-   Anita Rocha
-   Anne Etheridge
-   Anne Sofie Fink
-   Barbara Margagna
-   Barrie Nelson
-   Benjamin Zapilko
-   Bryan Fitzpatrick
-   Carsten Thiel
-   Chris Seymour
-   Christian Pichot
-   Chuck Humphrey
-   Cornelia Züll
-   Daniella Meeker
-   David Barraclough
-   Deirdre Lungley
-   Denis Grofils
-   Dennis Wegener
-   Doug Fils
-   Edouard Romari Batot
-   Elizabeth Hostetter
-   Esra Akdeniz
-   Fernando López Aguilar
-   Florio Arguillas
-   Franck Cotton
-   Gary Berg-Cross
-   George Alter
-   Gillian Kerr
-   Gregg Kellogg
-   Helen Toole
-   Henrik Sejersen
-   Hervé L'Hours
-   Hossein Abroshan
-   Ingo Barkow
-   Irena Vipavc Brvar
-   Iris Alfredsson
-   Johanna Vompras
-   John Kunze
-   John Shepherdson
-   Jon Stiles
-   Justin Lynch
-   Katherine McNeill
-   Katja Moilanen
-   Kerrin Borschewski
-   Klas Blomqvist
-   Laura Molloy
-   Marta Limmert
-   Martin Forsberg
-   Matthäus Zloch
-   Maude Frances
-   Mehmood Asghar
-   Merja Karjalainen
-   Michael Witt
-   Michel Dumontier
-   Natalja Menold
-   Nathan Cunningham
-   Neeraj Kashyap
-   Nick Car
-   Nicole Kirgis
-   Oleg Volguine
-   Pier Luigi Buttigieg
-   Pierre-Antoine Champin
-   Richard Cyganiak
-   Sam Hume
-   Simon Hodson
-   Simon Lloyd
-   Simon Wall
-   Sophia Kuan
-   Stuart Weibel
-   Taina Jääskeläinen
-   Thomas Bosch
-   Tito Castillo
-   Uwe Jensen
-   William Block

## The contributing people came from following organizations:

-   ABS - Australian Bureau of Statistics
-   AWI - Alfred Wegener Institute for Polar and Marine Research
-   Australian Data Archives, Australian National University
-   Booz, Allen, Hamilton
-   CDISC - Clinical Data Interchange Standards Consortium
-   CESSDA ERIC - Consortium of European Social Science Data Archives
    (European Research Infrastructure)
-   CISER - Cornell Institute for Social and Economic Research
-   CODATA - Committee on Data for Science and Technology
-   California Digital Library University of California
-   Colectica
-   Commonwealth Scientific and Industrial Research Organisation (CSIRO)
-   Consortium for Ocean Leadership
-   Danish Data Archive
-   Danish National Archives
-   Drexel University Metadata Research Center
-   Ecrucial Consulting Group, SDMX?
-   Environment Agency Austria
-   Eurostat
-   FSD - Finnish Social Science Data Archive
-   GESIS - Leibniz Institute for the Social Sciences
-   German Socio-Economic Panel (SOEP), German Institute for Economic
    Research (DIW Berlin)
-   HTW Chur, University of Applied Sciences
-   INSEE - French National Institute of Statistics and Economic Studies
-   Institute for Policy & Social Research, University of Kansas
-   Institute for Social Research, University of Michigan
-   Interuniversity Consortium for Political and Social Research
    (ICPSR), University of Michigan
-   LogicalOutcomes
-   Minnesota Population Center (MPC), University of Minnesota
-   NGSI-LD, FIWARE
-   NSD - Norwegian Centre for Research Data
-   National University of Ireland, Galway Digital Enterprise Research
    Institute (DERI)
-   NetCDF, INRAE - French National Institute of Agricultural Research
-   OCLC - Online Computer Library Center
-   OECD
-   Open University of Catalonia
-   Oxford e-Research Centre
-   Population Studies Center, University of Michigan
-   Portage Network, Canadian Association of Research Libraries
-   Purdue University Libraries
-   RDA - Research Data Alliance
-   Research Data Centre (FDZ) of the Federal Employment Agency,
    Institute for Employment Research (IAB)
-   Slovenian Social Science Data Archives (ADP)
-   Stanford University
-   Stanford University Libraries
-   Statistics Canada
-   Statistics Estonia
-   Statistics New Zealand
-   Statistics Norway
-   Statistics Sweden
-   Survey Research Center, University of Michigan
-   Swedish National Data Service (SND)
-   UKDA - UK Data Archive
-   UKDS - UK Data Service
-   US Bureau of Labor Statistics
-   University College London (UCL)
-   University College London Hospitals NHS Foundation Trust (UCLH)
-   University Library Bielefeld
-   University of California, Berkeley
-   University of New South Wales
-   University of Southern California Clinical Research Informatics
-   University of Toronto Libraries
-   University of Washington
-   University of Wisconsin, Madison Institute on Aging
-   World Bank
-   World Wide Web Consortium (W3C)
